module jp.ku6.windows.directx.d3d9;

import jp.ku6.windows.win32api.windef;
import jp.ku6.windows.win32api.basetyps;
import jp.ku6.windows.win32api.unknwn;
import jp.ku6.windows.win32api.wtypes;
import jp.ku6.windows.win32api.wingdi;
import jp.ku6.windows.directx.d3d9types;
import jp.ku6.windows.directx.d3d9caps;

immutable uint D3D_SDK_VERSION = 32;
immutable uint D3D9b_SDK_VERSION = 31;

immutable GUID IID_IDirect3D9                         = {0x81bdcbca, 0x64d4, 0x426d, [0xae, 0x8d, 0xad, 0x01, 0x47, 0xf4, 0x27, 0x5c]};
immutable GUID IID_IDirect3DDevice9                   = {0xd0223b96, 0xbf7a, 0x43fd, [0x92, 0xbd, 0xa4, 0x3b, 0x0d, 0x82, 0xb9, 0xeb]};
immutable GUID IID_IDirect3DResource9                 = {0x05eec05d, 0x8f7d, 0x4362, [0xb9, 0x99, 0xd1, 0xba, 0xf3, 0x57, 0xc7, 0x04]};
immutable GUID IID_IDirect3DBaseTexture9              = {0x580ca87e, 0x1d3c, 0x4d54, [0x99, 0x1d, 0xb7, 0xd3, 0xe3, 0xc2, 0x98, 0xce]};
immutable GUID IID_IDirect3DTexture9                  = {0x85c31227, 0x3de5, 0x4f00, [0x9b, 0x3a, 0xf1, 0x1a, 0xc3, 0x8c, 0x18, 0xb5]};
immutable GUID IID_IDirect3DCubeTexture9              = {0xfff32f81, 0xd953, 0x473a, [0x92, 0x23, 0x93, 0xd6, 0x52, 0xab, 0xa9, 0x3f]};
immutable GUID IID_IDirect3DVolumeTexture9            = {0x2518526c, 0xe789, 0x4111, [0xa7, 0xb9, 0x47, 0xef, 0x32, 0x8d, 0x13, 0xe6]};
immutable GUID IID_IDirect3DVertexBuffer9             = {0xb64bb1b5, 0xfd70, 0x4df6, [0xbf, 0x91, 0x19, 0xd0, 0xa1, 0x24, 0x55, 0xe3]};
immutable GUID IID_IDirect3DIndexBuffer9              = {0x7c9dd65e, 0xd3f7, 0x4529, [0xac, 0xee, 0x78, 0x58, 0x30, 0xac, 0xde, 0x35]};
immutable GUID IID_IDirect3DSurface9                  = {0x0cfbaf3a, 0x9ff6, 0x429a, [0x99, 0xb3, 0xa2, 0x79, 0x6a, 0xf8, 0xb8, 0x9b]};
immutable GUID IID_IDirect3DVolume9                   = {0x24f416e6, 0x1f67, 0x4aa7, [0xb8, 0x8e, 0xd3, 0x3f, 0x6f, 0x31, 0x28, 0xa1]};
immutable GUID IID_IDirect3DSwapChain9                = {0x794950f2, 0xadfc, 0x458a, [0x90, 0x5e, 0x10, 0xa1, 0x0b, 0x0b, 0x50, 0x3b]};
immutable GUID IID_IDirect3DVertexDeclaration9        = {0xdd13c59c, 0x36fa, 0x4098, [0xa8, 0xfb, 0xc7, 0xed, 0x39, 0xdc, 0x85, 0x46]};
immutable GUID IID_IDirect3DVertexShader9             = {0xefc5557e, 0x6265, 0x4613, [0x8a, 0x94, 0x43, 0x85, 0x78, 0x89, 0xeb, 0x36]};
immutable GUID IID_IDirect3DPixelShader9              = {0x6d3bdbdc, 0x5b02, 0x4415, [0xb8, 0x52, 0xce, 0x5e, 0x8b, 0xcc, 0xb2, 0x89]};
immutable GUID IID_IDirect3DStateBlock9               = {0xb07c4fe5, 0x310d, 0x4ba8, [0xa2, 0x3c, 0x4f, 0x0f, 0x20, 0x6f, 0x21, 0x8b]};
immutable GUID IID_IDirect3DQuery9                    = {0xd9771460, 0xa695, 0x4f26, [0xbb, 0xd3, 0x27, 0xb8, 0x40, 0xb5, 0x41, 0xcc]};
immutable GUID IID_HelperName                         = {0xe4a36723, 0xfdfe, 0x4b22, [0xb1, 0x46, 0x3c, 0x04, 0xc0, 0x7f, 0x4c, 0xc8]};
version (D3D_DISABLE_9EX)
{
}
else
{
	immutable GUID IID_IDirect3D9Ex                   = {0x02177241, 0x69FC, 0x400C, [0x8F, 0xF1, 0x93, 0xA4, 0x4D, 0xF6, 0x86, 0x1D]};
	immutable GUID IID_IDirect3DDevice9Ex             = {0xb18b10ce, 0x2649, 0x405a, [0x87, 0x0f, 0x95, 0xf7, 0x77, 0xd4, 0x31, 0x3a]};
	immutable GUID IID_IDirect3DSwapChain9Ex          = {0x91886caf, 0x1c3d, 0x4d2e, [0xa0, 0xab, 0x3e, 0x4c, 0x7d, 0x8d, 0x33, 0x03]};
	immutable GUID IID_IDirect3D9ExOverlayExtension   = {0x187aeb13, 0xaaf5, 0x4c59, [0x87, 0x6d, 0xe0, 0x59, 0x08, 0x8c, 0x0d, 0xf8]};
	immutable GUID IID_IDirect3DDevice9Video          = {0x26dc4561, 0xa1ee, 0x4ae7, [0x96, 0xda, 0x11, 0x8a, 0x36, 0xc0, 0xec, 0x95]};
	immutable GUID IID_IDirect3DAuthenticatedChannel9 = {0xff24beee, 0xda21, 0x4beb, [0x98, 0xb5, 0xd2, 0xf8, 0x99, 0xf9, 0x8a, 0xf9]};
	immutable GUID IID_IDirect3DCryptoSession9        = {0xfa0ab799, 0x7a9c, 0x48ca, [0x8c, 0x5b, 0x23, 0x7e, 0x71, 0xa5, 0x44, 0x34]};
}

extern (Windows)
{
	IDirect3D9 Direct3DCreate9(UINT SDKVersion);
	alias IDirect3D9 function(UINT SDKVersion) Direct3DCreate9Function;


	int D3DPERF_BeginEvent(D3DCOLOR col, LPCWSTR wszName);
	alias int function(D3DCOLOR col, LPCWSTR wszName) D3DPERF_BeginEventFunction;

	int D3DPERF_EndEvent();
	alias int function() D3DPERF_EndEventFunction;

	void D3DPERF_SetMarker(D3DCOLOR col, LPCWSTR wszName);
	alias void function(D3DCOLOR col, LPCWSTR wszName) D3DPERF_SetMarkerFunction;

	void D3DPERF_SetRegion(D3DCOLOR col, LPCWSTR wszName);
	alias void function(D3DCOLOR col, LPCWSTR wszName) D3DPERF_SetRegionFunction;

	BOOL D3DPERF_QueryRepeatFrame();
	alias BOOL function() D3DPERF_QueryRepeatFrameFunction;


	void D3DPERF_SetOptions(DWORD dwOptions);
	alias void function(DWORD dwOptions) D3DPERF_SetOptionsFunction;

	DWORD D3DPERF_GetStatus();
	alias DWORD function() D3DPERF_GetStatusFunction;
}

extern (Windows)
{
	interface IDirect3D9 : IUnknown
	{
		HRESULT RegisterSoftwareDevice(void* pInitializeFunction);
		UINT GetAdapterCount();
		HRESULT GetAdapterIdentifier(UINT Adapter, DWORD Flags, D3DADAPTER_IDENTIFIER9* pIdentifier);
		UINT GetAdapterModeCount(UINT Adapter, D3DFORMAT Format);
		HRESULT EnumAdapterModes(UINT Adapter, D3DFORMAT Format, UINT Mode, D3DDISPLAYMODE* pMode);
		HRESULT GetAdapterDisplayMode(UINT Adapter, D3DDISPLAYMODE* pMode);
		HRESULT CheckDeviceType(UINT Adapter, D3DDEVTYPE DevType, D3DFORMAT AdapterFormat, D3DFORMAT BackBufferFormat, BOOL bWindowed);
		HRESULT CheckDeviceFormat(UINT Adapter, D3DDEVTYPE DeviceType, D3DFORMAT AdapterFormat, DWORD Usage, D3DRESOURCETYPE RType, D3DFORMAT CheckFormat);
		HRESULT CheckDeviceMultiSampleType(UINT Adapter, D3DDEVTYPE DeviceType, D3DFORMAT SurfaceFormat, BOOL Windowed, D3DMULTISAMPLE_TYPE MultiSampleType, DWORD* pQualityLevels);
		HRESULT CheckDepthStencilMatch(UINT Adapter, D3DDEVTYPE DeviceType, D3DFORMAT AdapterFormat, D3DFORMAT RenderTargetFormat, D3DFORMAT DepthStencilFormat);
		HRESULT CheckDeviceFormatConversion(UINT Adapter, D3DDEVTYPE DeviceType, D3DFORMAT SourceFormat, D3DFORMAT TargetFormat);
		HRESULT GetDeviceCaps(UINT Adapter, D3DDEVTYPE DeviceType, D3DCAPS9* pCaps);
		HMONITOR GetAdapterMonitor(UINT Adapter);
		HRESULT CreateDevice(UINT Adapter, D3DDEVTYPE DeviceType, HWND hFocusWindow, DWORD BehaviorFlags, D3DPRESENT_PARAMETERS* pPresentationParameters, IDirect3DDevice9* ppReturnedDeviceInterface);
	}
	alias IDirect3D9 LPDIRECT3D9;
	alias IDirect3D9 PDIRECT3D9;

	interface IDirect3DDevice9 : IUnknown
	{
		HRESULT TestCooperativeLevel();
		UINT GetAvailableTextureMem();
		HRESULT EvictManagedResources();
		HRESULT GetDirect3D(IDirect3D9* ppD3D9);
		HRESULT GetDeviceCaps(D3DCAPS9* pCaps);
		HRESULT GetDisplayMode(UINT iSwapChain, D3DDISPLAYMODE* pMode);
		HRESULT GetCreationParameters(D3DDEVICE_CREATION_PARAMETERS* pParameters);
		HRESULT SetCursorProperties(UINT XHotSpot, UINT YHotSpot, IDirect3DSurface9 pCursorBitmap);
		void SetCursorPosition(int X, int Y, DWORD Flags);
		BOOL ShowCursor(BOOL bShow);
		HRESULT CreateAdditionalSwapChain(D3DPRESENT_PARAMETERS* pPresentationParameters, IDirect3DSwapChain9* pSwapChain);
		HRESULT GetSwapChain(UINT iSwapChain, IDirect3DSwapChain9* pSwapChain);
		UINT GetNumberOfSwapChains();
		HRESULT Reset(D3DPRESENT_PARAMETERS* pPresentationParameters);
		HRESULT Present(const(RECT)* pSourceRect, const(RECT)* pDestRect, HWND hDestWindowOverride, const(RGNDATA)* pDirtyRegion);
		HRESULT GetBackBuffer(UINT iSwapChain, UINT iBackBuffer, D3DBACKBUFFER_TYPE Type, IDirect3DSurface9* ppBackBuffer);
		HRESULT GetRasterStatus(UINT iSwapChain, D3DRASTER_STATUS* pRasterStatus);
		HRESULT SetDialogBoxMode(BOOL bEnableDialogs);
		void SetGammaRamp(UINT iSwapChain, DWORD Flags, const(D3DGAMMARAMP)* pRamp);
		void GetGammaRamp(UINT iSwapChain, D3DGAMMARAMP* pRamp);
		HRESULT CreateTexture(UINT Width, UINT Height, UINT Levels, DWORD Usage, D3DFORMAT Format, D3DPOOL Pool, IDirect3DTexture9* ppTexture, HANDLE* pSharedHandle);
		HRESULT CreateVolumeTexture(UINT Width, UINT Height, UINT Depth, UINT Levels, DWORD Usage, D3DFORMAT Format, D3DPOOL Pool, IDirect3DVolumeTexture9* ppVolumeTexture, HANDLE* pSharedHandle);
		HRESULT CreateCubeTexture(UINT EdgeLength, UINT Levels, DWORD Usage, D3DFORMAT Format, D3DPOOL Pool, IDirect3DCubeTexture9* ppCubeTexture, HANDLE* pSharedHandle);
		HRESULT CreateVertexBuffer(UINT Length, DWORD Usage, DWORD FVF, D3DPOOL Pool, IDirect3DVertexBuffer9* ppVertexBuffer, HANDLE* pSharedHandle);
		HRESULT CreateIndexBuffer(UINT Length, DWORD Usage, D3DFORMAT Format, D3DPOOL Pool, IDirect3DIndexBuffer9* ppIndexBuffer, HANDLE* pSharedHandle);
		HRESULT CreateRenderTarget(UINT Width, UINT Height, D3DFORMAT Format, D3DMULTISAMPLE_TYPE MultiSample, DWORD MultisampleQuality, BOOL Lockable, IDirect3DSurface9* ppSurface, HANDLE* pSharedHandle);
		HRESULT CreateDepthStencilSurface(UINT Width, UINT Height, D3DFORMAT Format, D3DMULTISAMPLE_TYPE MultiSample, DWORD MultisampleQuality, BOOL Discard, IDirect3DSurface9* ppSurface, HANDLE* pSharedHandle);
		HRESULT UpdateSurface(IDirect3DSurface9 pSourceSurface, const(RECT)* pSourceRect, IDirect3DSurface9 pDestinationSurface, const(POINT)* pDestPoint);
		HRESULT UpdateTexture(IDirect3DBaseTexture9 pSourceTexture, IDirect3DBaseTexture9 pDestinationTexture);
		HRESULT GetRenderTargetData(IDirect3DSurface9 pRenderTarget, IDirect3DSurface9 pDestSurface);
		HRESULT GetFrontBufferData(UINT iSwapChain, IDirect3DSurface9 pDestSurface);
		HRESULT StretchRect(IDirect3DSurface9 pSourceSurface, const(RECT)* pSourceRect, IDirect3DSurface9 pDestSurface, const(RECT)* pDestRect, D3DTEXTUREFILTERTYPE Filter);
		HRESULT ColorFill(IDirect3DSurface9 pSurface, const(RECT)* pRect, D3DCOLOR color);
		HRESULT CreateOffscreenPlainSurface(UINT Width, UINT Height, D3DFORMAT Format, D3DPOOL Pool, IDirect3DSurface9* ppSurface, HANDLE* pSharedHandle);
		HRESULT SetRenderTarget(DWORD RenderTargetIndex, IDirect3DSurface9 pRenderTarget);
		HRESULT GetRenderTarget(DWORD RenderTargetIndex, IDirect3DSurface9* ppRenderTarget);
		HRESULT SetDepthStencilSurface(IDirect3DSurface9 pNewZStencil);
		HRESULT GetDepthStencilSurface(IDirect3DSurface9* ppZStencilSurface);
		HRESULT BeginScene();
		HRESULT EndScene();
		HRESULT Clear(DWORD Count, const(D3DRECT)* pRects, DWORD Flags, D3DCOLOR Color, float Z, DWORD Stencil);
		HRESULT SetTransform(D3DTRANSFORMSTATETYPE State, const(D3DMATRIX)* pMatrix);
		HRESULT GetTransform(D3DTRANSFORMSTATETYPE State, D3DMATRIX* pMatrix);
		HRESULT MultiplyTransform(D3DTRANSFORMSTATETYPE State, const(D3DMATRIX)* pMatrix);
		HRESULT SetViewport(const(D3DVIEWPORT9)* pViewport);
		HRESULT GetViewport(D3DVIEWPORT9* pViewport);
		HRESULT SetMaterial(const(D3DMATERIAL9)* pMaterial);
		HRESULT GetMaterial(D3DMATERIAL9* pMaterial);
		HRESULT SetLight(DWORD Index, const(D3DLIGHT9)* pLight);
		HRESULT GetLight(DWORD Index, D3DLIGHT9* pLight);
		HRESULT LightEnable(DWORD Index, BOOL Enable);
		HRESULT GetLightEnable(DWORD Index, BOOL* pEnable);
		HRESULT SetClipPlane(DWORD Index, const(float)* pPlane);
		HRESULT GetClipPlane(DWORD Index, float* pPlane);
		HRESULT SetRenderState(D3DRENDERSTATETYPE State, DWORD Value);
		HRESULT GetRenderState(D3DRENDERSTATETYPE State, DWORD* pValue);
		HRESULT CreateStateBlock(D3DSTATEBLOCKTYPE Type, IDirect3DStateBlock9* ppSB);
		HRESULT BeginStateBlock();
		HRESULT EndStateBlock(IDirect3DStateBlock9* ppSB);
		HRESULT SetClipStatus(const(D3DCLIPSTATUS9)* pClipStatus);
		HRESULT GetClipStatus(D3DCLIPSTATUS9* pClipStatus);
		HRESULT GetTexture(DWORD Stage, IDirect3DBaseTexture9* ppTexture);
		HRESULT SetTexture(DWORD Stage, IDirect3DBaseTexture9 pTexture);
		HRESULT GetTextureStageState(DWORD Stage, D3DTEXTURESTAGESTATETYPE Type, DWORD* pValue);
		HRESULT SetTextureStageState(DWORD Stage, D3DTEXTURESTAGESTATETYPE Type, DWORD Value);
		HRESULT GetSamplerState(DWORD Sampler, D3DSAMPLERSTATETYPE Type, DWORD* pValue);
		HRESULT SetSamplerState(DWORD Sampler, D3DSAMPLERSTATETYPE Type, DWORD Value);
		HRESULT ValidateDevice(DWORD* pNumPasses);
		HRESULT SetPaletteEntries(UINT PaletteNumber, const(PALETTEENTRY)* pEntries);
		HRESULT GetPaletteEntries(UINT PaletteNumber, PALETTEENTRY* pEntries);
		HRESULT SetCurrentTexturePalette(UINT PaletteNumber);
		HRESULT GetCurrentTexturePalette(UINT* PaletteNumber);
		HRESULT SetScissorRect(const(RECT)* pRect);
		HRESULT GetScissorRect(RECT* pRect);
		HRESULT SetSoftwareVertexProcessing(BOOL bSoftware);
		BOOL GetSoftwareVertexProcessing();
		HRESULT SetNPatchMode(float nSegments);
		float GetNPatchMode();
		HRESULT DrawPrimitive(D3DPRIMITIVETYPE PrimitiveType, UINT StartVertex, UINT PrimitiveCount);
		HRESULT DrawIndexedPrimitive(D3DPRIMITIVETYPE PrimitiveType, INT BaseVertexIndex, UINT MinVertexIndex, UINT NumVertices, UINT startIndex, UINT primCount);
		HRESULT DrawPrimitiveUP(D3DPRIMITIVETYPE PrimitiveType, UINT PrimitiveCount, const(void)* pVertexStreamZeroData, UINT VertexStreamZeroStride);
		HRESULT DrawIndexedPrimitiveUP(D3DPRIMITIVETYPE PrimitiveType, UINT MinVertexIndex, UINT NumVertices, UINT PrimitiveCount, const(void)* pIndexData, D3DFORMAT IndexDataFormat, const(void)* pVertexStreamZeroData, UINT VertexStreamZeroStride);
		HRESULT ProcessVertices(UINT SrcStartIndex, UINT DestIndex, UINT VertexCount, IDirect3DVertexBuffer9 pDestBuffer, IDirect3DVertexDeclaration9 pVertexDecl, DWORD Flags);
		HRESULT CreateVertexDeclaration(const(D3DVERTEXELEMENT9)* pVertexElements, IDirect3DVertexDeclaration9* ppDecl);
		HRESULT SetVertexDeclaration(IDirect3DVertexDeclaration9 pDecl);
		HRESULT GetVertexDeclaration(IDirect3DVertexDeclaration9* ppDecl);
		HRESULT SetFVF(DWORD FVF);
		HRESULT GetFVF(DWORD* pFVF);
		HRESULT CreateVertexShader(const(DWORD)* pFunction, IDirect3DVertexShader9* ppShader);
		HRESULT SetVertexShader(IDirect3DVertexShader9 pShader);
		HRESULT GetVertexShader(IDirect3DVertexShader9* ppShader);
		HRESULT SetVertexShaderConstantF(UINT StartRegister, const(float)* pConstantData, UINT Vector4fCount);
		HRESULT GetVertexShaderConstantF(UINT StartRegister, float* pConstantData, UINT Vector4fCount);
		HRESULT SetVertexShaderConstantI(UINT StartRegister, const(int)* pConstantData, UINT Vector4iCount);
		HRESULT GetVertexShaderConstantI(UINT StartRegister, int* pConstantData, UINT Vector4iCount);
		HRESULT SetVertexShaderConstantB(UINT StartRegister, const(BOOL)* pConstantData, UINT  BoolCount);
		HRESULT GetVertexShaderConstantB(UINT StartRegister, BOOL* pConstantData, UINT BoolCount);
		HRESULT SetStreamSource(UINT StreamNumber, IDirect3DVertexBuffer9 pStreamData, UINT OffsetInBytes, UINT Stride);
		HRESULT GetStreamSource(UINT StreamNumber, IDirect3DVertexBuffer9* ppStreamData, UINT* pOffsetInBytes, UINT* pStride);
		HRESULT SetStreamSourceFreq(UINT StreamNumber, UINT Setting);
		HRESULT GetStreamSourceFreq(UINT StreamNumber, UINT* pSetting);
		HRESULT SetIndices(IDirect3DIndexBuffer9 pIndexData);
		HRESULT GetIndices(IDirect3DIndexBuffer9* ppIndexData);
		HRESULT CreatePixelShader(const(DWORD)* pFunction, IDirect3DPixelShader9* ppShader);
		HRESULT SetPixelShader(IDirect3DPixelShader9 pShader);
		HRESULT GetPixelShader(IDirect3DPixelShader9* ppShader);
		HRESULT SetPixelShaderConstantF(UINT StartRegister, const(float)* pConstantData, UINT Vector4fCount);
		HRESULT GetPixelShaderConstantF(UINT StartRegister, float* pConstantData, UINT Vector4fCount);
		HRESULT SetPixelShaderConstantI(UINT StartRegister, const(int)* pConstantData, UINT Vector4iCount);
		HRESULT GetPixelShaderConstantI(UINT StartRegister, int* pConstantData, UINT Vector4iCount);
		HRESULT SetPixelShaderConstantB(UINT StartRegister, const(BOOL)* pConstantData, UINT  BoolCount);
		HRESULT GetPixelShaderConstantB(UINT StartRegister, BOOL* pConstantData, UINT BoolCount);
		HRESULT DrawRectPatch(UINT Handle, const(float)* pNumSegs, const(D3DRECTPATCH_INFO)* pRectPatchInfo);
		HRESULT DrawTriPatch(UINT Handle, const(float)* pNumSegs, const(D3DTRIPATCH_INFO)* pTriPatchInfo);
		HRESULT DeletePatch(UINT Handle);
		HRESULT CreateQuery(D3DQUERYTYPE Type, IDirect3DQuery9* ppQuery);
	}
	alias IDirect3DDevice9 LPDIRECT3DDEVICE9;
	alias IDirect3DDevice9 PDIRECT3DDEVICE9;

	interface IDirect3DStateBlock9 : IUnknown
	{
		HRESULT GetDevice(IDirect3DDevice9* ppDevice);
		HRESULT Capture();
		HRESULT Apply();
	}
	alias IDirect3DStateBlock9 LPDIRECT3DSTATEBLOCK9;
	alias IDirect3DStateBlock9 PDIRECT3DSTATEBLOCK9;

	interface IDirect3DSwapChain9 : IUnknown
	{
		HRESULT Present(const(RECT)* pSourceRect, const(RECT)* pDestRect, HWND hDestWindowOverride, const(RGNDATA)* pDirtyRegion, DWORD dwFlags);
		HRESULT GetFrontBufferData(IDirect3DSurface9 pDestSurface);
		HRESULT GetBackBuffer(UINT iBackBuffer, D3DBACKBUFFER_TYPE Type, IDirect3DSurface9* ppBackBuffer);
		HRESULT GetRasterStatus(D3DRASTER_STATUS* pRasterStatus);
		HRESULT GetDisplayMode(D3DDISPLAYMODE* pMode);
		HRESULT GetDevice(IDirect3DDevice9* ppDevice);
		HRESULT GetPresentParameters(D3DPRESENT_PARAMETERS* pPresentationParameters);
	}
	alias IDirect3DSwapChain9 LPDIRECT3DSWAPCHAIN9;
	alias IDirect3DSwapChain9 PDIRECT3DSWAPCHAIN9;

	interface IDirect3DResource9 : IUnknown
	{
		HRESULT GetDevice(IDirect3DDevice9* ppDevice);
		HRESULT SetPrivateData(REFGUID refguid, const(void)* pData, DWORD SizeOfData, DWORD Flags);
		HRESULT GetPrivateData(REFGUID refguid, void* pData, DWORD* pSizeOfData);
		HRESULT FreePrivateData(REFGUID refguid);
		DWORD SetPriority(DWORD PriorityNew);
		DWORD GetPriority();
		void PreLoad();
		D3DRESOURCETYPE GetType();
	}
	alias IDirect3DResource9 LPDIRECT3DRESOURCE9;
	alias IDirect3DResource9 PDIRECT3DRESOURCE9;

	interface IDirect3DVertexDeclaration9 : IUnknown
	{
		HRESULT GetDevice(IDirect3DDevice9* ppDevice);
		HRESULT GetDeclaration(D3DVERTEXELEMENT9* pElement, UINT* pNumElements);
	}
	alias IDirect3DVertexDeclaration9 LPDIRECT3DVERTEXDECLARATION9;
	alias IDirect3DVertexDeclaration9 PDIRECT3DVERTEXDECLARATION9;

	interface IDirect3DVertexShader9 : IUnknown
	{
		HRESULT GetDevice(IDirect3DDevice9* ppDevice);
		HRESULT GetFunction(void*, UINT* pSizeOfData);
	}
	alias IDirect3DVertexShader9 LPDIRECT3DVERTEXSHADER9;
	alias IDirect3DVertexShader9 PDIRECT3DVERTEXSHADER9;

	interface IDirect3DPixelShader9 : IUnknown
	{
		HRESULT GetDevice(IDirect3DDevice9* ppDevice);
		HRESULT GetFunction(void*, UINT* pSizeOfData);
	}
	alias IDirect3DPixelShader9 LPDIRECT3DPIXELSHADER9;
	alias IDirect3DPixelShader9 PDIRECT3DPIXELSHADER9;

	interface IDirect3DBaseTexture9 : IDirect3DResource9
	{
		DWORD SetLOD(DWORD LODNew);
		DWORD GetLOD();
		DWORD GetLevelCount();
		HRESULT SetAutoGenFilterType(D3DTEXTUREFILTERTYPE FilterType);
		D3DTEXTUREFILTERTYPE GetAutoGenFilterType();
		void GenerateMipSubLevels();
	}
	alias IDirect3DBaseTexture9 LPDIRECT3DBASETEXTURE9;
	alias IDirect3DBaseTexture9 PDIRECT3DBASETEXTURE9;


	interface IDirect3DTexture9 : IDirect3DBaseTexture9
	{
		HRESULT GetLevelDesc(UINT Level, D3DSURFACE_DESC *pDesc);
		HRESULT GetSurfaceLevel(UINT Level, IDirect3DSurface9* ppSurfaceLevel);
		HRESULT LockRect(UINT Level, D3DLOCKED_RECT* pLockedRect, const(RECT)* pRect, DWORD Flags);
		HRESULT UnlockRect(UINT Level);
		HRESULT AddDirtyRect(const(RECT)* pDirtyRect);
	}
	alias IDirect3DTexture9 LPDIRECT3DTEXTURE9;
	alias IDirect3DTexture9 PDIRECT3DTEXTURE9;

	interface IDirect3DVolumeTexture9 : IDirect3DBaseTexture9
	{
		HRESULT GetLevelDesc(UINT Level, D3DVOLUME_DESC *pDesc);
		HRESULT GetVolumeLevel(UINT Level, IDirect3DVolume9* ppVolumeLevel);
		HRESULT LockBox(UINT Level, D3DLOCKED_BOX* pLockedVolume, const(D3DBOX)* pBox, DWORD Flags);
		HRESULT UnlockBox(UINT Level);
		HRESULT AddDirtyBox(const(D3DBOX)* pDirtyBox);
	}
	alias IDirect3DVolumeTexture9 LPDIRECT3DVOLUMETEXTURE9;
	alias IDirect3DVolumeTexture9 PDIRECT3DVOLUMETEXTURE9;

	interface IDirect3DCubeTexture9 : IDirect3DBaseTexture9
	{
		HRESULT GetLevelDesc(UINT Level, D3DSURFACE_DESC *pDesc);
		HRESULT GetCubeMapSurface(D3DCUBEMAP_FACES FaceType, UINT Level, IDirect3DSurface9* ppCubeMapSurface);
		HRESULT LockRect(D3DCUBEMAP_FACES FaceType, UINT Level, D3DLOCKED_RECT* pLockedRect, const(RECT)* pRect, DWORD Flags);
		HRESULT UnlockRect(D3DCUBEMAP_FACES FaceType, UINT Level);
		HRESULT AddDirtyRect(D3DCUBEMAP_FACES FaceType, const(RECT)* pDirtyRect);
	}
	alias IDirect3DCubeTexture9 LPDIRECT3DCUBETEXTURE9;
	alias IDirect3DCubeTexture9 PDIRECT3DCUBETEXTURE9;

	interface IDirect3DVertexBuffer9 : IDirect3DResource9
	{
		HRESULT Lock(UINT OffsetToLock, UINT SizeToLock, void** ppbData, DWORD Flags);
		HRESULT Unlock();
		HRESULT GetDesc(D3DVERTEXBUFFER_DESC* pDesc);
	}
	alias IDirect3DVertexBuffer9 LPDIRECT3DVERTEXBUFFER9;
	alias IDirect3DVertexBuffer9 PDIRECT3DVERTEXBUFFER9;

	interface IDirect3DIndexBuffer9 : IDirect3DResource9
	{
		HRESULT Lock(UINT OffsetToLock, UINT SizeToLock, void** ppbData, DWORD Flags);
		HRESULT Unlock();
		HRESULT GetDesc(D3DINDEXBUFFER_DESC* pDesc);
	}
	alias IDirect3DIndexBuffer9 LPDIRECT3DINDEXBUFFER9;
	alias IDirect3DIndexBuffer9 PDIRECT3DINDEXBUFFER9;

	interface IDirect3DSurface9 : IDirect3DResource9
	{
		HRESULT GetContainer(REFIID riid, void** ppContainer);
		HRESULT GetDesc(D3DSURFACE_DESC* pDesc);
		HRESULT LockRect(D3DLOCKED_RECT* pLockedRect, const(RECT)* pRect, DWORD Flags);
		HRESULT UnlockRect();
		HRESULT GetDC(HDC* phdc);
		HRESULT ReleaseDC(HDC hdc);
	}
	alias IDirect3DSurface9 LPDIRECT3DSURFACE9;
	alias IDirect3DSurface9 PDIRECT3DSURFACE9;

	interface IDirect3DVolume9 : IUnknown
	{
		HRESULT GetDevice(IDirect3DDevice9* ppDevice);
		HRESULT SetPrivateData(REFGUID refguid, const(void)* pData, DWORD SizeOfData, DWORD Flags);
		HRESULT GetPrivateData(REFGUID refguid, void* pData, DWORD* pSizeOfData);
		HRESULT FreePrivateData(REFGUID refguid);
		HRESULT GetContainer(REFIID riid, void** ppContainer);
		HRESULT GetDesc(D3DVOLUME_DESC* pDesc);
		HRESULT LockBox(D3DLOCKED_BOX* pLockedVolume, const(D3DBOX)* pBox, DWORD Flags);
		HRESULT UnlockBox();
	}
	alias IDirect3DVolume9 LPDIRECT3DVOLUME9;
	alias IDirect3DVolume9 PDIRECT3DVOLUME9;

	interface IDirect3DQuery9 : IUnknown
	{
		HRESULT GetDevice(IDirect3DDevice9* ppDevice);
		D3DQUERYTYPE GetType();
		DWORD GetDataSize();
		HRESULT Issue(DWORD dwIssueFlags);
		HRESULT GetData(void* pData, DWORD dwSize, DWORD dwGetDataFlags);
	}
	alias IDirect3DQuery9 LPDIRECT3DQUERY9;
	alias IDirect3DQuery9 PDIRECT3DQUERY9;
}

immutable uint D3DSPD_IUNKNOWN = 0x00000001;

immutable uint D3DCREATE_FPU_PRESERVE                 = 0x00000002;
immutable uint D3DCREATE_MULTITHREADED                = 0x00000004;
immutable uint D3DCREATE_PUREDEVICE                   = 0x00000010;
immutable uint D3DCREATE_SOFTWARE_VERTEXPROCESSING    = 0x00000020;
immutable uint D3DCREATE_HARDWARE_VERTEXPROCESSING    = 0x00000040;
immutable uint D3DCREATE_MIXED_VERTEXPROCESSING       = 0x00000080;
immutable uint D3DCREATE_DISABLE_DRIVER_MANAGEMENT    = 0x00000100;
immutable uint D3DCREATE_ADAPTERGROUP_DEVICE          = 0x00000200;
immutable uint D3DCREATE_DISABLE_DRIVER_MANAGEMENT_EX = 0x00000400;
immutable uint D3DCREATE_NOWINDOWCHANGES              = 0x00000800;
version (D3D_DISABLE_9EX)
{
}
else
{
	immutable uint D3DCREATE_DISABLE_PSGP_THREADING   = 0x00002000;
	immutable uint D3DCREATE_ENABLE_PRESENTSTATS      = 0x00004000;
	immutable uint D3DCREATE_DISABLE_PRINTSCREEN      = 0x00008000;
	immutable uint D3DCREATE_SCREENSAVER              = 0x10000000;
}

immutable uint D3DADAPTER_DEFAULT = 0;

immutable uint D3DENUM_WHQL_LEVEL = 0x00000002;
version (D3D_DISABLE_9EX)
{
}
else
{
	immutable uint D3DENUM_NO_DRIVERVERSION = 0x00000004;
}


immutable uint D3DPRESENT_BACK_BUFFERS_MAX = 3;
version (D3D_DISABLE_9EX)
{
}
else
{
	immutable uint D3DPRESENT_BACK_BUFFERS_MAX_EX = 30;
}

immutable uint D3DSGR_NO_CALIBRATION = 0x00000000;
immutable uint D3DSGR_CALIBRATE      = 0x00000001;

immutable uint D3DCURSOR_IMMEDIATE_UPDATE = 0x00000001;

immutable uint D3DPRESENT_DONOTWAIT      = 0x00000001;
immutable uint D3DPRESENT_LINEAR_CONTENT = 0x00000002;
version (D3D_DISABLE_9EX)
{
}
else
{
	immutable uint D3DPRESENT_DONOTFLIP                 = 0x00000004;
	immutable uint D3DPRESENT_FLIPRESTART               = 0x00000008;
	immutable uint D3DPRESENT_VIDEO_RESTRICT_TO_MONITOR = 0x00000010;
	immutable uint D3DPRESENT_UPDATEOVERLAYONLY         = 0x00000020;
	immutable uint D3DPRESENT_HIDEOVERLAY               = 0x00000040;
	immutable uint D3DPRESENT_UPDATECOLORKEY            = 0x00000080;
	immutable uint D3DPRESENT_FORCEIMMEDIATE            = 0x00000100;
}

immutable ushort _FACD3D = 0x876;

template MAKE_D3DHRESULT(ushort code)
{
	immutable HRESULT MAKE_D3DHRESULT = MAKE_HRESULT!(1, _FACD3D, code);
}

template MAKE_D3DSTATUS(ushort code)
{
	immutable HRESULT MAKE_D3DSTATUS = MAKE_HRESULT!(0, _FACD3D, code);
}

immutable HRESULT D3D_OK = S_OK;

immutable HRESULT D3DERR_WRONGTEXTUREFORMAT        = MAKE_D3DHRESULT!(2072);
immutable HRESULT D3DERR_UNSUPPORTEDCOLOROPERATION = MAKE_D3DHRESULT!(2073);
immutable HRESULT D3DERR_UNSUPPORTEDCOLORARG       = MAKE_D3DHRESULT!(2074);
immutable HRESULT D3DERR_UNSUPPORTEDALPHAOPERATION = MAKE_D3DHRESULT!(2075);
immutable HRESULT D3DERR_UNSUPPORTEDALPHAARG       = MAKE_D3DHRESULT!(2076);
immutable HRESULT D3DERR_TOOMANYOPERATIONS         = MAKE_D3DHRESULT!(2077);
immutable HRESULT D3DERR_CONFLICTINGTEXTUREFILTER  = MAKE_D3DHRESULT!(2078);
immutable HRESULT D3DERR_UNSUPPORTEDFACTORVALUE    = MAKE_D3DHRESULT!(2079);
immutable HRESULT D3DERR_CONFLICTINGRENDERSTATE    = MAKE_D3DHRESULT!(2081);
immutable HRESULT D3DERR_UNSUPPORTEDTEXTUREFILTER  = MAKE_D3DHRESULT!(2082);
immutable HRESULT D3DERR_CONFLICTINGTEXTUREPALETTE = MAKE_D3DHRESULT!(2086);
immutable HRESULT D3DERR_DRIVERINTERNALERROR       = MAKE_D3DHRESULT!(2087);
immutable HRESULT D3DERR_NOTFOUND                  = MAKE_D3DHRESULT!(2150);
immutable HRESULT D3DERR_MOREDATA                  = MAKE_D3DHRESULT!(2151);
immutable HRESULT D3DERR_DEVICELOST                = MAKE_D3DHRESULT!(2152);
immutable HRESULT D3DERR_DEVICENOTRESET            = MAKE_D3DHRESULT!(2153);
immutable HRESULT D3DERR_NOTAVAILABLE              = MAKE_D3DHRESULT!(2154);
immutable HRESULT D3DERR_OUTOFVIDEOMEMORY          = MAKE_D3DHRESULT!(380);
immutable HRESULT D3DERR_INVALIDDEVICE             = MAKE_D3DHRESULT!(2155);
immutable HRESULT D3DERR_INVALIDCALL               = MAKE_D3DHRESULT!(2156);
immutable HRESULT D3DERR_DRIVERINVALIDCALL         = MAKE_D3DHRESULT!(2157);
immutable HRESULT D3DERR_WASSTILLDRAWING           = MAKE_D3DHRESULT!(540);
immutable HRESULT D3DOK_NOAUTOGEN                  = MAKE_D3DSTATUS!(2159);

version (D3D_DISABLE_9EX)
{
}
else
{
	immutable HRESULT D3DERR_DEVICEREMOVED               = MAKE_D3DHRESULT!(2160);
	immutable HRESULT S_NOT_RESIDENT                     = MAKE_D3DSTATUS!(2165);
	immutable HRESULT S_RESIDENT_IN_SHARED_MEMORY        = MAKE_D3DSTATUS!(2166);
	immutable HRESULT S_PRESENT_MODE_CHANGED             = MAKE_D3DSTATUS!(2167);
	immutable HRESULT S_PRESENT_OCCLUDED                 = MAKE_D3DSTATUS!(2168);
	immutable HRESULT D3DERR_DEVICEHUNG                  = MAKE_D3DHRESULT!(2164);
	immutable HRESULT D3DERR_UNSUPPORTEDOVERLAY          = MAKE_D3DHRESULT!(2171);
	immutable HRESULT D3DERR_UNSUPPORTEDOVERLAYFORMAT    = MAKE_D3DHRESULT!(2172);
	immutable HRESULT D3DERR_CANNOTPROTECTCONTENT        = MAKE_D3DHRESULT!(2173);
	immutable HRESULT D3DERR_UNSUPPORTEDCRYPTO           = MAKE_D3DHRESULT!(2174);
	immutable HRESULT D3DERR_PRESENT_STATISTICS_DISJOINT = MAKE_D3DHRESULT!(2180);


	extern (Windows)
	{
		HRESULT Direct3DCreate9Ex(UINT SDKVersion, IDirect3D9Ex* pDirect3D9Ex);
		alias HRESULT function(UINT SDKVersion, IDirect3D9Ex* pDirect3D9Ex) Direct3DCreate9ExFunction;

		interface IDirect3D9Ex : IDirect3D9
		{
			UINT GetAdapterModeCountEx(UINT Adapter, const(D3DDISPLAYMODEFILTER)* pFilter );
			HRESULT EnumAdapterModesEx(UINT Adapter, const(D3DDISPLAYMODEFILTER)* pFilter, UINT Mode, D3DDISPLAYMODEEX* pMode);
			HRESULT GetAdapterDisplayModeEx(UINT Adapter, D3DDISPLAYMODEEX* pMode, D3DDISPLAYROTATION* pRotation);
			HRESULT CreateDeviceEx(UINT Adapter, D3DDEVTYPE DeviceType, HWND hFocusWindow, DWORD BehaviorFlags, D3DPRESENT_PARAMETERS* pPresentationParameters, D3DDISPLAYMODEEX* pFullscreenDisplayMode, IDirect3DDevice9Ex* ppReturnedDeviceInterface);
			HRESULT GetAdapterLUID(UINT Adapter, LUID * pLUID);
		}
		alias IDirect3D9Ex LPDIRECT3D9EX;
		alias IDirect3D9Ex PDIRECT3D9EX;

		interface IDirect3DDevice9Ex : IDirect3DDevice9
		{
			HRESULT SetConvolutionMonoKernel(UINT width, UINT height, float* rows, float* columns);
			HRESULT ComposeRects(IDirect3DSurface9 pSrc, IDirect3DSurface9 pDst, IDirect3DVertexBuffer9 pSrcRectDescs, UINT NumRects, IDirect3DVertexBuffer9 pDstRectDescs, D3DCOMPOSERECTSOP Operation, int Xoffset, int Yoffset);
			HRESULT PresentEx(const(RECT)* pSourceRect, const(RECT)* pDestRect, HWND hDestWindowOverride, const(RGNDATA)* pDirtyRegion, DWORD dwFlags);
			HRESULT GetGPUThreadPriority(INT* pPriority);
			HRESULT SetGPUThreadPriority(INT Priority);
			HRESULT WaitForVBlank(UINT iSwapChain);
			HRESULT CheckResourceResidency(IDirect3DResource9* pResourceArray, UINT32 NumResources);
			HRESULT SetMaximumFrameLatency(UINT MaxLatency);
			HRESULT GetMaximumFrameLatency(UINT* pMaxLatency);
			HRESULT CheckDeviceState(HWND hDestinationWindow);
			HRESULT CreateRenderTargetEx(UINT Width, UINT Height, D3DFORMAT Format, D3DMULTISAMPLE_TYPE MultiSample, DWORD MultisampleQuality, BOOL Lockable, IDirect3DSurface9* ppSurface, HANDLE* pSharedHandle, DWORD Usage);
			HRESULT CreateOffscreenPlainSurfaceEx(UINT Width, UINT Height, D3DFORMAT Format, D3DPOOL Pool, IDirect3DSurface9* ppSurface, HANDLE* pSharedHandle, DWORD Usage);
			HRESULT CreateDepthStencilSurfaceEx(UINT Width, UINT Height, D3DFORMAT Format, D3DMULTISAMPLE_TYPE MultiSample, DWORD MultisampleQuality, BOOL Discard, IDirect3DSurface9* ppSurface, HANDLE* pSharedHandle, DWORD Usage);
			HRESULT ResetEx(D3DPRESENT_PARAMETERS* pPresentationParameters, D3DDISPLAYMODEEX *pFullscreenDisplayMode);
			HRESULT GetDisplayModeEx(UINT iSwapChain, D3DDISPLAYMODEEX* pMode, D3DDISPLAYROTATION* pRotation);
		}
		alias IDirect3DDevice9Ex LPDIRECT3DDEVICE9EX;
		alias IDirect3DDevice9Ex PDIRECT3DDEVICE9EX;

		interface IDirect3DSwapChain9Ex : IDirect3DSwapChain9
		{
			HRESULT GetLastPresentCount(UINT* pLastPresentCount);
			HRESULT GetPresentStats(D3DPRESENTSTATS* pPresentationStatistics);
			HRESULT GetDisplayModeEx(D3DDISPLAYMODEEX* pMode, D3DDISPLAYROTATION* pRotation);
		}
		alias IDirect3DSwapChain9Ex LPDIRECT3DSWAPCHAIN9EX;
		alias IDirect3DSwapChain9Ex PDIRECT3DSWAPCHAIN9EX;

		interface IDirect3D9ExOverlayExtension : IUnknown
		{
			HRESULT CheckDeviceOverlayType(UINT Adapter, D3DDEVTYPE DevType, UINT OverlayWidth, UINT OverlayHeight, D3DFORMAT OverlayFormat, D3DDISPLAYMODEEX* pDisplayMode, D3DDISPLAYROTATION DisplayRotation, D3DOVERLAYCAPS* pOverlayCaps);
		}
		alias IDirect3D9ExOverlayExtension LPDIRECT3D9EXOVERLAYEXTENSION;
		alias IDirect3D9ExOverlayExtension PDIRECT3D9EXOVERLAYEXTENSION;

		interface IDirect3DDevice9Video : IUnknown
		{
			HRESULT GetContentProtectionCaps(const(GUID)* pCryptoType, const(GUID)* pDecodeProfile, D3DCONTENTPROTECTIONCAPS* pCaps);
			HRESULT CreateAuthenticatedChannel(D3DAUTHENTICATEDCHANNELTYPE ChannelType, IDirect3DAuthenticatedChannel9* ppAuthenticatedChannel, HANDLE* pChannelHandle);
			HRESULT CreateCryptoSession(const(GUID)* pCryptoType, const(GUID)* pDecodeProfile, IDirect3DCryptoSession9* ppCryptoSession, HANDLE* pCryptoHandle);
		}
		alias IDirect3DDevice9Video LPDIRECT3DDEVICE9VIDEO;
		alias IDirect3DDevice9Video PDIRECT3DDEVICE9VIDEO;

		interface IDirect3DAuthenticatedChannel9 : IUnknown
		{
			HRESULT GetCertificateSize(UINT* pCertificateSize);
			HRESULT GetCertificate(UINT CertifacteSize, BYTE* ppCertificate);
			HRESULT NegotiateKeyExchange(UINT DataSize, VOID* pData);
			HRESULT Query(UINT InputSize, const(VOID)* pInput, UINT OutputSize, VOID* pOutput);
			HRESULT Configure(UINT InputSize, const(VOID)* pInput, D3DAUTHENTICATEDCHANNEL_CONFIGURE_OUTPUT* pOutput);
		}
		alias IDirect3DAuthenticatedChannel9 LPDIRECT3DAUTHENTICATEDCHANNEL9;
		alias IDirect3DAuthenticatedChannel9 PDIRECT3DAUTHENTICATEDCHANNEL9;

		interface IDirect3DCryptoSession9 : IUnknown
		{
			HRESULT GetCertificateSize(UINT* pCertificateSize);
			HRESULT GetCertificate(UINT CertifacteSize, BYTE* ppCertificate);
			HRESULT NegotiateKeyExchange(UINT DataSize, VOID* pData);
			HRESULT EncryptionBlt(IDirect3DSurface9 pSrcSurface, IDirect3DSurface9 pDstSurface, UINT DstSurfaceSize, VOID* pIV);
			HRESULT DecryptionBlt(IDirect3DSurface9 pSrcSurface, IDirect3DSurface9 pDstSurface, UINT SrcSurfaceSize, D3DENCRYPTED_BLOCK_INFO* pEncryptedBlockInfo, VOID* pContentKey, VOID* pIV);
			HRESULT GetSurfacePitch(IDirect3DSurface9* pSrcSurface, UINT* pSurfacePitch);
			HRESULT StartSessionKeyRefresh(VOID* pRandomNumber, UINT RandomNumberSize);
			HRESULT FinishSessionKeyRefresh();
			HRESULT GetEncryptionBltKey(VOID* pReadbackKey, UINT KeySize);
		}
		alias IDirect3DCryptoSession9 LPDIRECT3DCRYPTOSESSION9;
		alias IDirect3DCryptoSession9 PDIRECT3DCRYPTOSESSION9;
	}
}